Subject: Re: Network hangs with 2.6.30.5

From: Eric Dumazet <[email-masked]>
Date: Tue, 01 Sep 2009 12:47:46 +0200

Clifford Heath a écrit :
> I sent this email last Friday, but received no response.
> 
> As far as I can see, some recent work in the stable
> Linux kernel has broken the TCP stack, at least on my
> (pretty common) hardware. Can anyone confirm that
> they've seen and perhaps fixed similar symptoms, or
> at least tell me what else I need to do to help them
> identify the problem?
> 
> I recently upgraded my Debian system (a Dell Optiplex GX270) from a
> 2.6.16.11 kernel to a 2.6.30.5 one (current stable). My networking is
> now misbehaving. If I could revert to an earlier kernel, I would (and
> did, it worked), but now I can't because of the glibc version change;
> the old kernel panics on startup. This leaves me with a *broken
> computer* which I cannot use for my regular work, and cannot afford to
> completely re-install.
> 
> POP, IMAP, and NNTP connect ok (multiple packets each way, viewed using
> a logging proxy; no tcpdump but I can get one for you) but as soon as a
> message should start coming down, the connection hangs and then times
> out. I think it's the first large packet that causes this, and I saw
> that the net team have been working on some features to increase
> throughput through read aggregation or something... Whatever it is, it's
> clearly broken (on my hardware at least).
> 
> My kernel .config file and the output of "lspci" are included below.
> Thanks for any help you can give. Let me know if you need more information.
> 

You could provide a tcpdump for example, and tell us which way is broken 
(your machine receiving a big packet, or sending a big packet)

You might try to change /proc/sys/net/ipv4/tcp_ecn to 0
echo 0 >/proc/sys/net/ipv4/tcp_ecn

You might try to change device settings

ethtool -K eth0 sg off
and various settings as well (tso, gso ...)